﻿local GarrisonDone = ...

if (not GarrisonDone_Vars) then GarrisonDone_Vars = {} end

if (not GarrisonDoneAltsFrame) then GarrisonDoneAltsFrame = GarrisonDoneAltsFrame end


local character = UnitName("player").."-"..GetRealmName();


        -- ALTS MISSION FRAME STARTS HERE --
        -- Wrote this Part from about 3 different addons so My Gratefull Thanks to those who went before me --
        -- Most of the code was from Garrison Timer by Zaman, My Thanks and appreciation for his initial work --
   

local GarrisonDone_Update_Log = 0
local GarrisonDone_Update_Frequency = 120
local GarrisonDoneAltsFrame_Update_Log = 0


local GarrisonDone_StartTime = 0
local maxBars = 9
local barList = {}
local unUsedBars = {}
local totalBars = 0

local tempSortedList = {}

local sortOrders = {
		{name = "Default", value = "default"},
    --    {name = "Character", value = "character"},
	--	{name = "Time", value = "time"},
	--	{name = "Is Rare" , value = "israre"}
		
	}
    
-- One of Timers for Timer DCF, cheap low maintenace hack way of doing this --
-- C_Timer.After(180, function() GarrisonDone_DispTimer(self, elapsed) end) -- Testing Timer Green out for release --          
C_Timer.After(1800, function() GarrisonDone_DispTimer(self, elapsed) end)
C_Timer.After(3600, function() GarrisonDone_DispTimer(self, elapsed) end)
C_Timer.After(5400, function() GarrisonDone_DispTimer(self, elapsed) end)
C_Timer.After(7200, function() GarrisonDone_DispTimer(self, elapsed) end)
C_Timer.After(9000, function() GarrisonDone_DispTimer(self, elapsed) end)
C_Timer.After(10800, function() GarrisonDone_DispTimer(self, elapsed) end)
C_Timer.After(12600, function() GarrisonDone_DispTimer(self, elapsed) end)
C_Timer.After(14400, function() GarrisonDone_DispTimer(self, elapsed) end)
C_Timer.After(16200, function() GarrisonDone_DispTimer(self, elapsed) end)
C_Timer.After(18000, function() GarrisonDone_DispTimer(self, elapsed) end)
       
            
            -- List Missions in DCF on Timer --  
function GarrisonDone_DispTimer(self, elapsed)
    if GarrisonDone_Varsc.disptimer == true then
        GarrisonDone_Display(self, elapsed)
    elseif GarrisonDone_Varsc.disptimer ~= true then
        return
    end
end

            -- List Missions in DCF on Login --
C_Timer.After(40, function() GarrisonDone_ShowLogin() end)
function GarrisonDone_ShowLogin()
    if GarrisonDone_Varsc.logintimer == true then
        GarrisonDone_Display(self, elapsed)
    elseif GarrisonDone_Varsc.logintimer ~= true then
        return
    end
end
            
            -- List Missions in DCF --
function GarrisonDone_Display(self, elapsed)
  --  if not UnitAffectingCombat("player") then
	if GarrisonDone_Vars then
		for realm, v1 in pairs(GarrisonDone_Vars) do
			for character, v2 in pairs(v1) do
				for missionId, data in pairs(v2) do
					    local color = "|cffE6CC80"
					    -- Set Class Colors --
                        if data.isRare ~= true then 
                        if data.class == "Death Knight" then color = "|cffC41F3B"
                        elseif data.class == "Druid" then color = "|cffFF7D0A"
                        elseif data.class == "Hunter" then color = "|cffABD473"
                        elseif data.class == "Mage" then color = "|cff69CCF0"
                        elseif data.class == "Monk" then color = "|cff00FF96"
                        elseif data.class == "Paladin" then color = "|cffF58CBA"
                        elseif data.class == "Priest" then color = "|cffFFFFFF"
                        elseif data.class == "Rogue" then color = "|cffFFF569"
                        elseif data.class == "Shaman" then color = "|cff0070DE"
                        elseif data.class == "Warlock" then color = "|cff9482C9"
                        elseif data.class == "Warrior" then color = "|cffC79C6E"
                            end
                        end
                        -- Change to Rare Blue for Rare Missions --
					    if data.isRare == true then
                        if data.class == "Death Knight" then color = "|cff0070FFR |cffC41F3B"
                        elseif data.class == "Druid" then color = "|cff0070FFR |cffFF7D0A"
                        elseif data.class == "Hunter" then color = "|cff0070FFR |cffABD473"
                        elseif data.class == "Mage" then color = "|cff0070FFR |cff69CCF0"
                        elseif data.class == "Monk" then color = "|cff0070FFR |cff00FF96"
                        elseif data.class == "Paladin" then color = "|cff0070FFR |cffF58CBA"
                        elseif data.class == "Priest" then color = "|cff0070FFR |cffFFFFFF"
                        elseif data.class == "Rogue" then color = "|cff0070FFR |cffFFF569"
                        elseif data.class == "Shaman" then color = "|cff0070FFR |cff0070DE"
                        elseif data.class == "Warlock" then color = "|cff0070FFR |cff9482C9"
                        elseif data.class == "Warrior" then color = "|cff0070FFR |cffC79C6E"
                            end
                        end
					    if data.endTime < time() then
						    print(color..character.."-"..realm.." : |cffE6CC80"..data.name.." : |cff1EFF0Ccompleted")
				    end
			    end
		    end
	    end
    end
end


            -- rotate the bar frames so we dont waste resources --
function GarrisonDone_Rebuild()
	local template = "GarrisonDone_"..GetRealmName().."_"..GetUnitName("player").."_"
	for index, object in pairs(barList) do
		if string.find("GarrisonDone_"..GetRealmName().."_"..GetUnitName("player").."_", index) then
			unUsedBars[#unUsedBars + 1] = object
			object.bar:Hide()
			barList[index] = nil
		end
	end
	GarrisonDone_Vars[GetRealmName()][GetUnitName("player")] = {}
	GarrisonDone_UpdateData()
end

            -- Clean out old Missions --
function GarrisonDone_Cleanup()
	local missionsLeft = {}
	local updatePending = false
	local mt = C_Garrison.GetInProgressMissions()
	for index, v in ipairs(mt) do
		missionsLeft[#missionsLeft + 1] = v.missionID
	end
	if GarrisonDone_Vars[GetRealmName()][GetUnitName("player")] then
		for j = #GarrisonDone_Vars[GetRealmName()][GetUnitName("player")], 1, -1 do
			local value = GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][j]
			local exists = false
			for i = 1,#missionsLeft,1 do
				if missionsLeft[i] == value.missionID then
					exists = true
				end
			end
			if not exists then
				tremove(GarrisonDone_Vars[GetRealmName()][GetUnitName("player")], j)
				if barList["GarrisonDone_"..GetRealmName().."_"..GetUnitName("player").."_"..value.missionID] then
					unUsedBars[#unUsedBars + 1] = barList["GarrisonDone_"..GetRealmName().."_"..GetUnitName("player").."_"..value.missionID]
					barList["GarrisonDone_"..GetRealmName().."_"..GetUnitName("player").."_"..value.missionID].bar:Hide()
					barList["GarrisonDone_"..GetRealmName().."_"..GetUnitName("player").."_"..value.missionID] = nil
					updatePending = true
				end
			end
		end
	end
	if updatePending then
		local i = 0
		if GarrisonDone_Vars then
			for id, object in pairs(barList) do
				object.bar:ClearAllPoints()
				object.bar:SetPoint("TOPLEFT", "GarrisonDoneAltsFrame", 30, -60-15*i)
				i = i + 1
			end
		end
	end
end

                -- Get the Missions and there times and save the variables --
function GarrisonDone_UpdateData(data)
    --/run for key,value in pairs(C_Garrison.GetInProgressMissions()[1]) do print(key, value) end
	local mt = C_Garrison.GetInProgressMissions()
	for index, v in ipairs(mt) do
		if(type(v) == "table") then
			local newIndex = #GarrisonDone_Vars[GetRealmName()][GetUnitName("player")] + 1
			local endTime = time()
			local num = select('#',strsplit(" ",v.timeLeft))
			local detailedTime = false
			for i = 1, num, 2 do
				local var = select(i,strsplit(" ",v.timeLeft))
				local unit = select(i+1,strsplit(" ",v.timeLeft))
				if(unit == "days") then
					endTime = endTime + var*24*3600
				elseif(unit == "hr") then
					endTime = endTime + var*3600
				elseif(unit == "min") then
					endTime = endTime + var*60
				elseif(unit == "sec") then
					endTime = endTime + var
					detailedTime = true
				end
			end
			if(data and data.missionID and data.missionID == v.missionID) then
				data.timeLeft = v.timeLeft
				data.endTime = endTime
				data.detailedTime = true
			elseif (not data) then
				if( not GarrisonDone_Vars) then
					GarrisonDone_Vars = {}
				end
				if (not GarrisonDone_Vars[GetRealmName()]) then
					GarrisonDone_Vars[GetRealmName()] = {}
				end
				if( not GarrisonDone_Vars[GetRealmName()][GetUnitName("player")]) then
					GarrisonDone_Vars[GetRealmName()][GetUnitName("player")] = {}
				end
				newIndex = GarrisonDone_InTable(GarrisonDone_Vars[GetRealmName()][GetUnitName("player")], v.missionID, newIndex)
				if( not GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex] ) then
					GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex] = {}
				end
				GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].name = v.name
				GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].followerTypeID = v.followerTypeID
                GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].description = v.description
				GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].type = v.type
				GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].isRare = v.isRare
				GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].durationSeconds = v.durationSeconds
				GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].timeLeft = v.timeLeft
				GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].missionID = v.missionID
				GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].endTime = endTime
				GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].realm = GetRealmName()
				GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].character = GetUnitName("player")
                GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].class = UnitClass("player")
				if not GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].displayed then
					GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].displayed = false
				end
				if not GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].detailedTime then
					GarrisonDone_Vars[GetRealmName()][GetUnitName("player")][newIndex].detailedTime = detailedTime
				end
			end
		end
	end
  --  DEFAULT_CHAT_FRAME:AddMessage("Sir We have Updated Our Missions List") -- debug
end

            -- Let the Mission Table take control --
function GarrisonDone_InTable(tab, missionID, oldIndex)
	for i = 1, #tab, 1 do
		if(tab[i].missionID == missionID) then
			return i
		end
	end
	return oldIndex
end


            -- Start Counter for Missions Complete Chat Dialog --
C_Timer.After(60, function() GarrisonDone_Mipcomplete() end)

function GarrisonDone_Mipcomplete()
            -- 10 min loop scan --
        C_Timer.After(600, function() GarrisonDone_MissComp(self, elapsed) end)
end
            -- Display completed missions in chat frame. 10 min loop --
function GarrisonDone_MissComp(self, elapsed)
        local MGDtimer = true
        if MGDtimer == true then
		if GarrisonDone_Vars then
			for realm, v1 in pairs(GarrisonDone_Vars) do
				for character, v2 in pairs(v1) do
					for missionId, data in pairs(v2) do
						if ((data.endTime < time()) and (data.displayed == false)) then
							if not data.detailedTime then
							local color = "|cffE6CC80"
					        -- Set Class Colors --
                        if data.isRare ~= true then 
                        if data.class == "Death Knight" then color = "|cff20ff20MGD |cffC41F3B"
                        elseif data.class == "Druid" then color = "|cff20ff20MGD |cffFF7D0A"
                        elseif data.class == "Hunter" then color = "|cff20ff20MGD |cffABD473"
                        elseif data.class == "Mage" then color = "|cff20ff20MGD |cff69CCF0"
                        elseif data.class == "Monk" then color = "|cff20ff20MGD |cff00FF96"
                        elseif data.class == "Paladin" then color = "|cff20ff20MGD |cffF58CBA"
                        elseif data.class == "Priest" then color = "|cff20ff20MGD |cffFFFFFF"
                        elseif data.class == "Rogue" then color = "|cff20ff20MGD |cffFFF569"
                        elseif data.class == "Shaman" then color = "|cff20ff20MGD |cff0070DE"
                        elseif data.class == "Warlock" then color = "|cff20ff20MGD |cff9482C9"
                        elseif data.class == "Warrior" then color = "|cff20ff20MGD |cffC79C6E"
                            end
                        end
                            -- Add Rare Blue "R" for Rare Missions --
					    if data.isRare == true then
                        if data.class == "Death Knight" then color = "|cff20ff20MGD |cff0070FFR |cffC41F3B"
                        elseif data.class == "Druid" then color = "|cff20ff20MGD |cff0070FFR |cffFF7D0A"
                        elseif data.class == "Hunter" then color = "|cff20ff20MGD |cff0070FFR |cffABD473"
                        elseif data.class == "Mage" then color = "|cff20ff20MGD |cff0070FFR |cff69CCF0"
                        elseif data.class == "Monk" then color = "|cff20ff20MGD |cff0070FFR |cff00FF96"
                        elseif data.class == "Paladin" then color = "|cff20ff20MGD |cff0070FFR |cffF58CBA"
                        elseif data.class == "Priest" then color = "|cff20ff20MGD |cff0070FFR |cffFFFFFF"
                        elseif data.class == "Rogue" then color = "|cff20ff20MGD |cff0070FFR |cffFFF569"
                        elseif data.class == "Shaman" then color = "|cff20ff20MGD |cff0070FFR |cff0070DE"
                        elseif data.class == "Warlock" then color = "|cff20ff20MGD |cff0070FFR |cff9482C9"
                        elseif data.class == "Warrior" then color = "|cff20ff20MGD |cff0070FFR |cffC79C6E"
                            end
                        end
						    DEFAULT_CHAT_FRAME:AddMessage(color..character.."-"..realm.." : |cffE6CC80"..data.name.." : |cffFF8000Completed")
					        end
				        end
			        end
		        end
	        end
        end
        GarrisonDone_Mipcomplete() -- Start the timer again --
    end
end


                -- Load the Bars that will make up the list --
function GarrisonDoneAltsFrame_OnLoad(self)
	for i = 1, maxBars, 1 do
		    bar = CreateFrame("StatusBar", "GarrisonDone_bar_"..i, GarrisonDoneAltsScrollFrame)
		    bar:SetWidth(300)
		    bar:SetHeight(18)
		    bar:SetOrientation("HORIZONTAL")
            local backdrop = {
                bgFile = "Interface\AddOns\GarrisonDone\images\StatusBar7",  
                edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Border",
                tile = false,
                edgeSize = 2,
                insets = {
                    left = 1,
                    right = 1,
                    top = 1,
                    bottom = 1
                }
            }
            bar:SetBackdrop(backdrop)
            bar:Raise()
            bar:SetBackdropColor(0, 0, 0, 0.4)
		    altMGDLabel = bar:CreateFontString("GarrisonDone_label_"..i, "ARTWORK", "GameFontNormalMed2")
		    altMGDLabel:SetTextHeight(12)
		    altMGDLabel:SetTextColor(0, 11, 44, 10)
		    altMGDLabel:SetPoint("LEFT", 10, 0, bar)
		    altMGDLabel:SetPoint("RIGHT", bar)
		    altMGDLabel:SetJustifyH("LEFT")
		    altMGDLabel:SetNonSpaceWrap(true)
		    bar:SetPoint("TOPLEFT", "GarrisonDoneAltsScrollFrame", 15, 18-19*(i))
		    bar:SetPoint("RIGHT", "GarrisonDoneAltsScrollFrame", 0, 0)
	end
end


            -- We have the Data now update the frame to show it - can we add a blank frame between names ?? --
function GarrisonDoneAltsFrame_OnUpdate(self, elapsed)
	--    if not UnitAffectingCombat("player") then
        if GarrisonDoneAltsFrame:IsShown() == true then
	    GarrisonDoneAltsFrame_Update_Log = 0
		if GarrisonDoneAltsFrame_Update_Log <= 0 then
			local i = 0
			local b = 0 
				if GarrisonDone_Vars then
					for realm, v1 in pairs(GarrisonDone_Vars) do
						for character, v2 in pairs(v1) do
							for index, data in pairs(v2) do
								i = i + 1
								local offset = FauxScrollFrame_GetOffset(GarrisonDoneAltsScrollFrame)
								if i > offset and i <= (offset + maxBars) then
									b = b + 1
									local name = data.name
									local t = data.endTime - time()
									local bar, texture, label, altMGDLabel, object
									local missionID = data.missionID
									bar = _G["GarrisonDone_bar_"..b]
									altMGDLabel = _G["GarrisonDone_label_"..b]
                                    
									
                                    local color = "|cffE6CC80"
                                        -- Set Class Colors --
                                    if data.isRare ~= true then 
                                    altMGDLabel:SetPoint("LEFT", 10, 0, bar)
                                    if data.class == "Death Knight" then color = "|cffC41F3B"
                                    elseif data.class == "Druid" then color = "|cffFF7D0A"
                                    elseif data.class == "Hunter" then color = "|cffABD473"
                                    elseif data.class == "Mage" then color = "|cff69CCF0"
                                    elseif data.class == "Monk" then color = "|cff00FF96"
                                    elseif data.class == "Paladin" then color = "|cffF58CBA"
                                    elseif data.class == "Priest" then color = "|cffFFFFFF"
                                    elseif data.class == "Rogue" then color = "|cffFFF569"
                                    elseif data.class == "Shaman" then color = "|cff0070DE"
                                    elseif data.class == "Warlock" then color = "|cff9482C9"
                                    elseif data.class == "Warrior" then color = "|cffC79C6E"
                                        end
                                    end
                                        -- Change to Rare Blue for Rare Missions --
									if data.isRare == true then
                                    altMGDLabel:SetPoint("LEFT", 1, 0, bar)
                                    if data.class == "Death Knight" then color = "|cff0070FFR |cffC41F3B"
                                    elseif data.class == "Druid" then color = "|cff0070FFR |cffFF7D0A"
                                    elseif data.class == "Hunter" then color = "|cff0070FFR |cffABD473"
                                    elseif data.class == "Mage" then color = "|cff0070FFR |cff69CCF0"
                                    elseif data.class == "Monk" then color = "|cff0070FFR |cff00FF96"
                                    elseif data.class == "Paladin" then color = "|cff0070FFR |cffF58CBA"
                                    elseif data.class == "Priest" then color = "|cff0070FFR |cffFFFFFF"
                                    elseif data.class == "Rogue" then color = "|cff0070FFR |cffFFF569"
                                    elseif data.class == "Shaman" then color = "|cff0070FFR |cff0070DE"
                                    elseif data.class == "Warlock" then color = "|cff0070FFR |cff9482C9"
                                    elseif data.class == "Warrior" then color = "|cff0070FFR |cffC79C6E"
                                        end
                                    end
                                    if data.followerTypeID == 2 then
                                    altMGDLabel:SetPoint("LEFT", 1, 0, bar)
                                    if data.class == "Death Knight" then color = "|cffFF8000S |cffC41F3B"
                                    elseif data.class == "Druid" then color = "|cffFF8000S |cffFF7D0A"
                                    elseif data.class == "Hunter" then color = "|cffFF8000S |cffABD473"
                                    elseif data.class == "Mage" then color = "|cffFF8000S |cff69CCF0"
                                    elseif data.class == "Monk" then color = "|cffFF8000S |cff00FF96"
                                    elseif data.class == "Paladin" then color = "|cffFF8000S |cffF58CBA"
                                    elseif data.class == "Priest" then color = "|cffFF8000S |cffFFFFFF"
                                    elseif data.class == "Rogue" then color = "|cffFF8000S |cffFFF569"
                                    elseif data.class == "Shaman" then color = "|cffFF8000S |cff0070DE"
                                    elseif data.class == "Warlock" then color = "|cffFF8000S |cff9482C9"
                                    elseif data.class == "Warrior" then color = "|cffFF8000S |cffC79C6E"
                                        end
                                    end
									if t > 60 then
										bar:SetValue(floor(t))
										altMGDLabel:SetText(string.format("%s: %02d:%02d", color..character.."-"..realm:sub(1,4)..":|cffE6CC80 "..name:sub(1,20).."|cff00FAF6", floor(t/3600), floor(mod(t,3600)/60)))
									else
                                            -- When Seconds reach Zero the Mission is Done --
										if data.detailedTime == false and realm == GetRealmName() and character == GetUnitName("player") then
											GarrisonDone_UpdateData(data)
										end
										altMGDLabel:SetText(string.format("%s: |cff1EFF0CReady", color..character.."-"..realm:sub(1,4)..":|cffE6CC80 "..name:sub(1,20)..""))
									end
									bar:Show()
                                end								
							end 
						end
					end
				end  
			    FauxScrollFrame_Update(GarrisonDoneAltsScrollFrame, i, maxBars, 15)
			    if b <= maxBars then
				    b = b + 1
				for j = b,maxBars do
					_G["GarrisonDone_bar_"..j]:Hide()
				    end
			    end
		    end
            if GarrisonDoneAltsFrame:IsShown() == true then
		        GarrisonDoneAltsScrollFrame:Show()
	        else
		        GarrisonDoneAltsFrame:Hide()
        --    end
        end
	end
end

        -- old Update the Scroll Bar --
function GarrisonDoneAltsFrame_ScrollBar_Update()
	       -- GarrisonDoneAltsFrame_OnUpdate(nil, 2) -- this was changed and now updates at 1274 -- 
end
 

function GarrisonDoneAltsSort_OnLoad()
	        for i = 1, #sortOrders do
		    info = {
			    text = sortOrders[i].name;
			    value = sortOrders[i].value;
		    }
	end
end 
            -- END ALTS SCROLL FRAME --
            